/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package school.schoolbook.forms;

import school.FormActions;
import school.schoolbook.Schoolbook;
import school.schoolbook.SchoolbookService;
import school.students.Student;
import school.students.StudentsService;
import school.teachers.Teacher;
import school.teachers.TeachersService;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *
 * @author Betina
 */
public class Mark extends javax.swing.JFrame {
    private Schoolbook selectedMark;
    private final StudentsService studentService;
    private final TeachersService teacherService;
    private final SchoolbookService schoolbookService;
    private FormActions formActions;

    /**
     * Creates new form Mark
     */
    public Mark(FormActions formActions) {
        initComponents();
        this.studentService = new StudentsService();
        this.teacherService = new TeachersService();
        this.schoolbookService = new SchoolbookService();
        this.formActions = formActions;
        initProps();
    }

    public Mark(Schoolbook schoolBook, FormActions formActions) {
        initComponents();
        this.selectedMark = schoolBook;
        this.studentService = new StudentsService();
        this.teacherService = new TeachersService();
        this.schoolbookService = new SchoolbookService();
        this.formActions = formActions;
        initProps();
    }

    public Mark() {
        initComponents();
        this.studentService = new StudentsService();
        this.teacherService = new TeachersService();
        this.schoolbookService = new SchoolbookService();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        studentLabel = new javax.swing.JLabel();
        teacherLabel = new javax.swing.JLabel();
        markLabel = new javax.swing.JLabel();
        enteredLabel = new javax.swing.JLabel();
        mark = new javax.swing.JTextField();
        teacher = new javax.swing.JComboBox<>();
        student = new javax.swing.JComboBox<>();
        entered = new javax.swing.JTextField();
        save = new javax.swing.JButton();
        back = new javax.swing.JButton();
        deleteButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setBackground(new java.awt.Color(0, 153, 153));

        jLabel1.setFont(new java.awt.Font("Segoe UI", 0, 18)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Mark");

        studentLabel.setFont(new java.awt.Font("Segoe UI", 0, 14)); // NOI18N
        studentLabel.setForeground(new java.awt.Color(255, 255, 255));
        studentLabel.setText("Student");

        teacherLabel.setFont(new java.awt.Font("Segoe UI", 0, 14)); // NOI18N
        teacherLabel.setForeground(new java.awt.Color(255, 255, 255));
        teacherLabel.setText("Teacher");

        markLabel.setFont(new java.awt.Font("Segoe UI", 0, 14)); // NOI18N
        markLabel.setForeground(new java.awt.Color(255, 255, 255));
        markLabel.setText("Mark");

        enteredLabel.setFont(new java.awt.Font("Segoe UI", 0, 14)); // NOI18N
        enteredLabel.setForeground(new java.awt.Color(255, 255, 255));
        enteredLabel.setText("Entered");

        mark.setText("mark");

        entered.setText("entered");

        save.setText("Save");
        save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveActionPerformed(evt);
            }
        });

        back.setText("Back");
        back.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                backActionPerformed(evt);
            }
        });

        deleteButton.setText("Delete");
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(406, 406, 406)
                        .addComponent(jLabel1))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(281, 281, 281)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(studentLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(teacherLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(markLabel)
                            .addComponent(enteredLabel))
                        .addGap(62, 62, 62)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(mark)
                            .addComponent(teacher, 0, 163, Short.MAX_VALUE)
                            .addComponent(student, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(entered))))
                .addContainerGap(316, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(save, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(back, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(deleteButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(396, 396, 396))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(38, 38, 38)
                .addComponent(jLabel1)
                .addGap(51, 51, 51)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(studentLabel)
                    .addComponent(student, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(35, 35, 35)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(teacherLabel)
                    .addComponent(teacher, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(39, 39, 39)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(markLabel)
                    .addComponent(mark, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(32, 32, 32)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(enteredLabel)
                    .addComponent(entered, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 120, Short.MAX_VALUE)
                .addComponent(deleteButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(save)
                .addGap(40, 40, 40)
                .addComponent(back)
                .addGap(35, 35, 35))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void saveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveActionPerformed
        Schoolbook schoolbook = new Schoolbook((Student) student.getSelectedItem(), (Teacher) teacher.getSelectedItem(), Double.valueOf(mark.getText()), new Date());
        schoolbookService.addMark(schoolbook);
    }//GEN-LAST:event_saveActionPerformed

    private void backActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_backActionPerformed
        JFrame marksPanel = new SchoolbookForm();
        marksPanel.setVisible(true);
        dispose();
    }//GEN-LAST:event_backActionPerformed

    private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
        this.schoolbookService.deleteMark(this.selectedMark.getId());
    }//GEN-LAST:event_deleteButtonActionPerformed

    private void initProps() {
        setStudents();
        setTeachers();
        if (this.formActions.equals(FormActions.CREATE)) {
            this.deleteButton.setVisible(false);
        } else {
            this.save.setVisible(false);
            this.mark.setText(this.selectedMark.getMark().toString());
            this.entered.setText(this.selectedMark.getEntered().toString());
        }
    }

    private void setTeachers() {
        List<Teacher> teachers = new ArrayList<>();
        if (this.selectedMark != null) {
            teachers.add(this.selectedMark.getTeacher());

        } else {
            teachers = this.teacherService.getTeachers();
        }
        if (!teachers.isEmpty()) {
            for (Teacher teacher : teachers) {
                this.teacher.addItem(teacher);
            }

            this.teacher.setSelectedIndex(0);
            initTeacherCombobox();
        }
    }

    private void setStudents() {
        List<Student> students = new ArrayList<>();
        if (this.selectedMark != null) {
            students.add(this.selectedMark.getStudent());

        } else {
            students = this.studentService.getStudents();
        }
        if (!students.isEmpty()) {
            for (Student student : students) {
                this.student.addItem(student);
            }
            this.student.setSelectedIndex(0);
            initStudentCombobox();
        }
    }

    private void initTeacherCombobox() {
        this.teacher.setRenderer(new DefaultListCellRenderer() {
            @Override
            public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);

                if (value != null) {
                    Teacher person = (Teacher) value;
                    StringBuilder sb = new StringBuilder();
                    sb.append(person.getFirstName()).append(" ").append(person.getLastName());
                    setText(sb.toString());
                } else {
                    setText("(No teachers)");
                }
                return this;
            }
        });
    }

    private void initStudentCombobox() {
        this.student.setRenderer(new DefaultListCellRenderer() {
            @Override
            public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);

                if (value != null) {
                    Student person = (Student) value;
                    StringBuilder sb = new StringBuilder();
                    sb.append(person.getFirstName()).append(" ").append(person.getLastName());
                    setText(sb.toString());
                } else {
                    setText("(No students)");
                }
                return this;
            }
        });
    }


    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Mark.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Mark.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Mark.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Mark.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Mark().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton back;
    private javax.swing.JButton deleteButton;
    private javax.swing.JTextField entered;
    private javax.swing.JLabel enteredLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTextField mark;
    private javax.swing.JLabel markLabel;
    private javax.swing.JButton save;
    private javax.swing.JComboBox<Student> student;
    private javax.swing.JLabel studentLabel;
    private javax.swing.JComboBox<Teacher> teacher;
    private javax.swing.JLabel teacherLabel;
    // End of variables declaration//GEN-END:variables
}
